<?php
// +------------------------------------------------------------------------+
// | @author		<xuxu.fr@gmail.com>
// | @version 		1.1 (2013/12/27) XN
// | @version 		1.0 (2013/12/24) XN
// | Copyright 		(c) 2013 Xuan NGUYEN
// +------------------------------------------------------------------------+

if (!empty($_COOKIE['fb_user_id'])) { // Login!
	//
	$args = array(
		'orderby' => 'display_name',
		'order' => 'ASC',
		'blog_id'=>1,
		'meta_key'=>'boobook_fb_user_id',
		'meta_value'=>$_COOKIE['fb_user_id']
	);
	$the_query = new WP_User_Query($args);
	$users = $the_query->get_results();

	//
	$boobook_fb_app_id = get_option('boobook_fb_app_id');
	$boobook_fb_app_secret = get_option('boobook_fb_app_secret');
	//
	$facebook = new Facebook(array(
		'appId'=>$boobook_fb_app_id,
		'secret'=>$boobook_fb_app_secret,
		'cookie'=>true
	));
	$fb_user = $facebook->getUser();

	if(isset($fb_user) && !empty($fb_user)) {
		try {
			$fb_user_profile = $facebook->api('/me');
		} catch(FacebookApiException $e) {
			error_log($e);
			$fb_user = NULL;
		}

		$fb_user_profile['email'] = (!empty($fb_user_profile['email'])) ? $fb_user_profile['email'] : "";
		$fb_user_profile['gender'] = (!empty($fb_user_profile['gender'])) ? $fb_user_profile['gender'] : "";
		$fb_user_profile['name'] = (!empty($fb_user_profile['name'])) ? str_replace("'", "\'", $fb_user_profile['name']) : "";
		$fb_user_profile['first_name'] = (!empty($fb_user_profile['first_name'])) ? str_replace("'", "\'", $fb_user_profile['first_name']) : "";
		$fb_user_profile['last_name'] = (!empty($fb_user_profile['last_name'])) ? str_replace("'", "\'", $fb_user_profile['last_name']) : "";
		$fb_user_profile['middle_name'] = (!empty($fb_user_profile['middle_name'])) ? str_replace("'", "\'", $fb_user_profile['middle_name']) : "";
		$fb_user_profile['bio'] = (!empty($fb_user_profile['bio'])) ? str_replace("'", "\'", $fb_user_profile['bio']) : "";
		$fb_user_profile['quotes'] = (!empty($fb_user_profile['quotes'])) ? str_replace("'", "\'", $fb_user_profile['quotes']) : "";

		do_action('boobook_fb_user_profile', $fb_user_profile);

		if (sizeof($users) == 0) {
			//echo "CREATION<br />";
			//
			$random_password = wp_generate_password($length = 8, $include_standard_special_chars = false);
			$user_id = wp_create_user($fb_user_profile['username'], $random_password, $fb_user_profile['email']);

			//
			$boobook_role_default = get_option('boobook_role_default');
			$U = new WP_User($user_id);
			$U->add_role($boobook_role_default);

			//
			do_action('boobook_user_created', $user_id);

			// send mail
			$blogname = get_bloginfo('name');
			$mailadmin = get_bloginfo('admin_email');

			//
			$boobook_register_notif = get_option('boobook_register_notif');
			if (!empty($boobook_register_notif) && $boobook_register_notif > 0) {
				//$attachments = array( WP_CONTENT_DIR . '/uploads/file_to_attach.zip');
				$attachments = "";
				$headers = 'From: '.$blogname.' <'.$mailadmin.'>'."\r\n";
				$message = "
					<strong>Un nouvel utilisateur Facebook vient de s'inscrire.</strong><br />
					<p>Email : <strong>".$fb_user_profile['email']."</strong></p>
					<p>Nom & prénom : <strong>".$fb_user_profile['name']."</strong></p>
				";
				wp_mail($mailadmin, '['.$blogname.'] Nouvelle inscription : '.$name, $message, $headers, $attachments);
			}
		}
		else {
			//echo "USER EXIST<br />";
			$user_id = $users[0]->ID;
		}

		// print_r($users);
		// echo "\$user_id = $user_id<hr />";
		// exit;

		$params = array(
			"ID"=>$user_id,
			"last_name"=>$fb_user_profile['last_name'],
			"first_name"=>$fb_user_profile['first_name'],
			"display_name"=>$fb_user_profile['name'],
			"description"=>$fb_user_profile['bio'],
		);

		//print_r($fb_user_profile);

		//
		do_action('boobook_user_before_update', $user_id, $params);

		//
		wp_update_user($params);

		//
	   	update_user_meta($user_id, 'boobook_fb_user_id', $_COOKIE['fb_user_id']);

	   	// avatar manage
		$picture_path = "https://graph.facebook.com/".$_COOKIE['fb_user_id']."/picture?redirect=false&width=1024";
		$json = file_get_contents($picture_path);
		$json = json_decode($json);

		$boobook_fb_picture_max = get_user_meta($user_id, 'boobook_fb_picture_max', 1);
		$boobook_fb_picture_max_width = get_user_meta($user_id, 'boobook_fb_picture_max_width', 1);
		$boobook_fb_picture_max_height = get_user_meta($user_id, 'boobook_fb_picture_max_height', 1);

		//$avatar_filename = 'boobook_avatar_'.$user_id.'_'.$_COOKIE['fb_user_id'].'.png';
		$avatar_filename = "boobook_".$user_id."_".$_COOKIE['fb_user_id']."_".basename($json->data->url);

		$upload_dir = wp_upload_dir();
		$final_url = $upload_dir['url']."/".$avatar_filename;
		$final_path = $upload_dir['path']."/".$avatar_filename;

		if (
			empty($boobook_fb_picture_max)
			|| (
				!empty($boobook_fb_picture_max) && $boobook_fb_picture_max != $json->data->url &&
				!empty($boobook_fb_picture_max_width) && $boobook_fb_picture_max_width != $json->data->width &&
				!empty($boobook_fb_picture_max_height) && $boobook_fb_picture_max_height != $json->data->height
			)
			||
			!file_exists($final_path)
		) {			
		   	// Avatar manage
		   	$f = fopen($json->data->url, 'r');
			$contents = '';
			while (!feof($f)) { $contents .= fread($f, 8192); }
			fclose($f);

		   	$f = fopen($final_path, 'w+');
		   	fwrite($f, $contents);
		   	fclose($f);

			$wp_filetype = wp_check_filetype(basename($final_path), null);
			$attachment = array(
				'guid' => $upload_dir['url'].'/'.basename($final_path), 
				'post_author' => $user_id,
				'post_type' => 'attachment',  
				'post_mime_type' => $wp_filetype['type'],
				'post_title' => preg_replace('/\.[^.]+$/', '', basename($final_path)),
				'post_content' => '',
				'post_status' => 'inherit'
			);
			$subpath = $upload_dir['subdir']."/".basename($final_path);
			$subpath = preg_replace("/^\//", "", $subpath);
			$attach_id = wp_insert_attachment($attachment, $subpath);

			// you must first include the image.php file
			// for the function wp_generate_attachment_metadata() to work
			require_once ABSPATH.'wp-admin/includes/image.php';
			$attach_data = wp_generate_attachment_metadata($attach_id, $final_path);
			wp_update_attachment_metadata($attach_id, $attach_data);

		   	update_user_meta($user_id, 'boobook_fb_picture_imported', $attach_id);


		   	update_user_meta($user_id, 'boobook_fb_picture_max', $json->data->url);
		   	update_user_meta($user_id, 'boobook_fb_picture_max_width', $json->data->width);
		   	update_user_meta($user_id, 'boobook_fb_picture_max_height', $json->data->height);

			//
			do_action('boobook_user_avatar_updated', $user_id, $attach_id);
		}


		// // do pic
		// $params = array(
		// 	'method'=>'fql.query',
		// 	"query"=>"SELECT uid,pic,pic_small,pic_square,pic_big,name,first_name,last_name,middle_name,email,profile_url,about_me,quotes FROM user WHERE uid = ".$_COOKIE['fb_user_id']
		// );
		// $result = $facebook->api($params);
		// //print_r($result);

	 //   	//
	 //   	update_user_meta($user_id, 'boobook_fb_picture', $result[0]['pic']);
	 //   	update_user_meta($user_id, 'boobook_fb_picture_square', $result[0]['pic_square']);
	 //   	update_user_meta($user_id, 'boobook_fb_picture_small', $result[0]['pic_small']);
	 //   	update_user_meta($user_id, 'boobook_fb_picture_big', $result[0]['pic_big']);
	 //   	update_user_meta($user_id, 'boobook_fb_picture_max', 'https://graph.facebook.com/'.$_COOKIE['fb_user_id'].'/picture?width=1024');

		//set cookie login
		//$result = wp_authenticate($fb_user_profile['username'], $random_password);
		wp_set_auth_cookie($user_id, $remember = true, $secure = '');

		//
		do_action('boobook_user_authenticated', $user_id);

		//
		$boobook_logged_redirect = get_option('boobook_logged_redirect');

		if (!empty($boobook_logged_redirect)) {
			wp_redirect($boobook_logged_redirect);
			exit;
		}
		else {
			wp_redirect($_SERVER['HTTP_REFERER']);
			exit;
		}
	}
	else {
		echo "Erreur, API Facebook n'a rien renvoyé.";
	}
}
else {
	echo "ERREUR, traitement impossible car cookie FB manquant.<hr />";
}